import ReactExports from 'react';
import { getDefaultStore } from 'jotai/vanilla';
import type { Atom, Getter, PrimitiveAtom, Setter, WritableAtom } from 'jotai/vanilla';
type SetAtom<Args extends unknown[], Result> = <A extends Args>(...args: A) => Result;
type Read<Value, SetSelf = never> = (get: Getter, options: {
    readonly signal: AbortSignal;
    readonly setSelf: SetSelf;
}) => Value;
type Write<Args extends unknown[], Result> = (get: Getter, set: Setter, ...args: Args) => Result;
type WithInitialValue<Value> = {
    init: Value;
};
type Store = ReturnType<typeof getDefaultStore>;
export declare const createElement: typeof ReactExports.createElement;
type AttachValue<T> = T & {
    value: T;
};
type Primitives = string | number | boolean | null | undefined;
export declare function $<T extends Primitives | Promise<Primitives>>(anAtom: Atom<T>, store?: Store): AttachValue<Awaited<T>>;
export declare function atomSignal<Value, Args extends unknown[], Result>(read: Read<Value, SetAtom<Args, Result>>, write: Write<Args, Result>, store?: Store): WritableAtom<Value, Args, Result> & (Value extends Primitives ? AttachValue<Value> : never);
export declare function atomSignal<Value>(read: Read<Value>, store?: Store): Atom<Value> & (Value extends Primitives ? AttachValue<Value> : never);
export declare function atomSignal<Value, Args extends unknown[], Result>(initialValue: Value, write: Write<Args, Result>, store?: Store): WritableAtom<Value, Args, Result> & WithInitialValue<Value> & (Value extends Primitives ? AttachValue<Value> : never);
export declare function atomSignal<Value>(initialValue: Value, write?: never, store?: Store): PrimitiveAtom<Value> & WithInitialValue<Value> & (Value extends Primitives ? AttachValue<Value> : never);
export {};
